// Code generated by the FlatBuffers compiler. DO NOT EDIT.

package fbtypes

import (
	flatbuffers "github.com/google/flatbuffers/go"
)

/// complete configuration of a single axis
type AxsCfgT struct {
	ObjectType string
	AxisProfileName string
	Limits *AxsCfgLimitsT
	Functions *AxsCfgFunctionsT
	Properties *AxsCfgPropertiesT
	Units *UnitCfgObjT
	KinProperties *AxsCfgKinPropertiesT
	DevErrReaction *AxsCfgDeviceErrorReactionT
	RtInputs *RTInputsCfgT
}

func (t *AxsCfgT) Pack(builder *flatbuffers.Builder) flatbuffers.UOffsetT {
	if t == nil { return 0 }
	objectTypeOffset := builder.CreateString(t.ObjectType)
	axisProfileNameOffset := builder.CreateString(t.AxisProfileName)
	limitsOffset := t.Limits.Pack(builder)
	functionsOffset := t.Functions.Pack(builder)
	propertiesOffset := t.Properties.Pack(builder)
	unitsOffset := t.Units.Pack(builder)
	kinPropertiesOffset := t.KinProperties.Pack(builder)
	devErrReactionOffset := t.DevErrReaction.Pack(builder)
	rtInputsOffset := t.RtInputs.Pack(builder)
	AxsCfgStart(builder)
	AxsCfgAddObjectType(builder, objectTypeOffset)
	AxsCfgAddAxisProfileName(builder, axisProfileNameOffset)
	AxsCfgAddLimits(builder, limitsOffset)
	AxsCfgAddFunctions(builder, functionsOffset)
	AxsCfgAddProperties(builder, propertiesOffset)
	AxsCfgAddUnits(builder, unitsOffset)
	AxsCfgAddKinProperties(builder, kinPropertiesOffset)
	AxsCfgAddDevErrReaction(builder, devErrReactionOffset)
	AxsCfgAddRtInputs(builder, rtInputsOffset)
	return AxsCfgEnd(builder)
}

func (rcv *AxsCfg) UnPackTo(t *AxsCfgT) {
	t.ObjectType = string(rcv.ObjectType())
	t.AxisProfileName = string(rcv.AxisProfileName())
	t.Limits = rcv.Limits(nil).UnPack()
	t.Functions = rcv.Functions(nil).UnPack()
	t.Properties = rcv.Properties(nil).UnPack()
	t.Units = rcv.Units(nil).UnPack()
	t.KinProperties = rcv.KinProperties(nil).UnPack()
	t.DevErrReaction = rcv.DevErrReaction(nil).UnPack()
	t.RtInputs = rcv.RtInputs(nil).UnPack()
}

func (rcv *AxsCfg) UnPack() *AxsCfgT {
	if rcv == nil { return nil }
	t := &AxsCfgT{}
	rcv.UnPackTo(t)
	return t
}

type AxsCfg struct {
	_tab flatbuffers.Table
}

func GetRootAsAxsCfg(buf []byte, offset flatbuffers.UOffsetT) *AxsCfg {
	n := flatbuffers.GetUOffsetT(buf[offset:])
	x := &AxsCfg{}
	x.Init(buf, n+offset)
	return x
}

func GetSizePrefixedRootAsAxsCfg(buf []byte, offset flatbuffers.UOffsetT) *AxsCfg {
	n := flatbuffers.GetUOffsetT(buf[offset+flatbuffers.SizeUint32:])
	x := &AxsCfg{}
	x.Init(buf, n+offset+flatbuffers.SizeUint32)
	return x
}

func (rcv *AxsCfg) Init(buf []byte, i flatbuffers.UOffsetT) {
	rcv._tab.Bytes = buf
	rcv._tab.Pos = i
}

func (rcv *AxsCfg) Table() flatbuffers.Table {
	return rcv._tab
}

/// object type (must be "Axis"), required for save/load
func (rcv *AxsCfg) ObjectType() []byte {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(4))
	if o != 0 {
		return rcv._tab.ByteVector(o + rcv._tab.Pos)
	}
	return nil
}

/// object type (must be "Axis"), required for save/load
/// name of the assigned axis profile or empty for virtual drives
func (rcv *AxsCfg) AxisProfileName() []byte {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(6))
	if o != 0 {
		return rcv._tab.ByteVector(o + rcv._tab.Pos)
	}
	return nil
}

/// name of the assigned axis profile or empty for virtual drives
/// all configured limits of this axis
func (rcv *AxsCfg) Limits(obj *AxsCfgLimits) *AxsCfgLimits {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(8))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(AxsCfgLimits)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// all configured limits of this axis
/// configuration for specific functions of this axis
func (rcv *AxsCfg) Functions(obj *AxsCfgFunctions) *AxsCfgFunctions {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(10))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(AxsCfgFunctions)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// configuration for specific functions of this axis
/// common axis properties of this axis
func (rcv *AxsCfg) Properties(obj *AxsCfgProperties) *AxsCfgProperties {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(12))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(AxsCfgProperties)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// common axis properties of this axis
/// general unit configuration of this axis
func (rcv *AxsCfg) Units(obj *UnitCfgObj) *UnitCfgObj {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(14))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(UnitCfgObj)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// general unit configuration of this axis
/// kinematic properties for axes
func (rcv *AxsCfg) KinProperties(obj *AxsCfgKinProperties) *AxsCfgKinProperties {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(16))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(AxsCfgKinProperties)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// kinematic properties for axes
/// device error reation settings
func (rcv *AxsCfg) DevErrReaction(obj *AxsCfgDeviceErrorReaction) *AxsCfgDeviceErrorReaction {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(18))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(AxsCfgDeviceErrorReaction)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// device error reation settings
/// configuration of the real-time inputs of the axis
func (rcv *AxsCfg) RtInputs(obj *RTInputsCfg) *RTInputsCfg {
	o := flatbuffers.UOffsetT(rcv._tab.Offset(20))
	if o != 0 {
		x := rcv._tab.Indirect(o + rcv._tab.Pos)
		if obj == nil {
			obj = new(RTInputsCfg)
		}
		obj.Init(rcv._tab.Bytes, x)
		return obj
	}
	return nil
}

/// configuration of the real-time inputs of the axis
func AxsCfgStart(builder *flatbuffers.Builder) {
	builder.StartObject(9)
}
func AxsCfgAddObjectType(builder *flatbuffers.Builder, objectType flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(0, flatbuffers.UOffsetT(objectType), 0)
}
func AxsCfgAddAxisProfileName(builder *flatbuffers.Builder, axisProfileName flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(1, flatbuffers.UOffsetT(axisProfileName), 0)
}
func AxsCfgAddLimits(builder *flatbuffers.Builder, limits flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(2, flatbuffers.UOffsetT(limits), 0)
}
func AxsCfgAddFunctions(builder *flatbuffers.Builder, functions flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(3, flatbuffers.UOffsetT(functions), 0)
}
func AxsCfgAddProperties(builder *flatbuffers.Builder, properties flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(4, flatbuffers.UOffsetT(properties), 0)
}
func AxsCfgAddUnits(builder *flatbuffers.Builder, units flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(5, flatbuffers.UOffsetT(units), 0)
}
func AxsCfgAddKinProperties(builder *flatbuffers.Builder, kinProperties flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(6, flatbuffers.UOffsetT(kinProperties), 0)
}
func AxsCfgAddDevErrReaction(builder *flatbuffers.Builder, devErrReaction flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(7, flatbuffers.UOffsetT(devErrReaction), 0)
}
func AxsCfgAddRtInputs(builder *flatbuffers.Builder, rtInputs flatbuffers.UOffsetT) {
	builder.PrependUOffsetTSlot(8, flatbuffers.UOffsetT(rtInputs), 0)
}
func AxsCfgEnd(builder *flatbuffers.Builder) flatbuffers.UOffsetT {
	return builder.EndObject()
}
